{ *********************************************************  }
{                     BINOMAL.pas                            }
{   berechnet Binomialverteilungen fr beliebiges n und p    }
{                               p      n-k                   }
{   Grundlage : B(n,p;k+1) =   --- *  ----- *B(n,p;k)        }
{                              1-p     1+k                   }
{                                                            }
{   in Anlehnung an die Funktionen pot, binkoeff, binomial   }
{                    aus TOOLBOX 12/89                       }
{                     TURBO PASCAL 5.0                       }
{ **************************************************P******  }

{$N+}
{$IFDEF CPU87} {$ELSE} {$E+} {$ENDIF}
{ emuliert den math. Coprozessor, wenn nicht vorhanden }

PROGRAM Binomialverteilung;

Uses
  Crt;

TYPE
  string6 = string[6];

VAR
binomi, sum, p, q                  : extended;
n, st                              : word;
m, x, y, grenze, zeile, i, l       : integer;
s,t,ja                             : char;
aus                                : text;
wahr,z                             : boolean;
n1,p1, binomi1, sum1               : string6;

CONST
   epsilon = 0.00005;
   maxein  = 65535;


PROCEDURE Hell;
Begin
 highvideo;
end;

PROCEDURE Norm;
Begin
 normvideo;
end;
PROCEDURE invers;
Begin
 textcolor(0); textbackground(7);
end;

PROCEDURE normal;
Begin
 textcolor(7); textbackground(0);
end;


FUNCTION BINOMIAL(n,k : word; p : extended) : extended;
{ Berechnet die Wahrscheinlichkeit B(n,p;k) zufuss }

Var
 max, min, j    : word;
 binko, faktor  : extended;

Begin
  q := 1 - p;
  if k < n - k then begin
    max := n-k;
    min := k;
    faktor := q;
    end
   else begin
    max := k;
    min := n-k;
    faktor := p;
    end;
   binko := 1;
   j := 1;
   while j <= (n-max) do begin
    binko := binko * (max+j)/j * p * q;
    inc(j);
   end;
   j := 1;
   while j <= (max - min) do begin
    binko := binko * faktor;
    inc(j);
   end;
  binomial := binko;
end;


PROCEDURE Eingabe;

BEGIN
 clrscr;
 gotoxy(1,1);
 writeln ('            ******************************************************* ');
 writeln ('            *      Berechnung von Binomialverteilungen            * ');
 writeln ('            ******************************************************* ');
 writeln; writeln;
 writeln ('            Bitte geben Sie die Parameter ein: ');
 writeln;
 write   ('                                     n = ');
 x := whereX; y := whereY;
 repeat
  gotoxy(x,y);
  clreol;
  readln(n)
 until ((n>0) and (n < maxein));

 writeln;
 write   ('                                     p = ');

 x := whereX; y := whereY;
 repeat
  gotoxy(x,y);
  clreol;
  readln(p)
 until ((p > 0) and (p < 1));

q := 1-p;
str(n:5,n1);
str(p:5:4,p1);
writeln; writeln;

repeat
   write('            Ausgabe auf dem (');
   hell; write('B');norm;
   write(')ildschirm oder auf dem (');
   hell; write('D');norm;
   write(')rucker ? ');
   read(t);
   t := upcase(t)
  until t in ['B','D'];
  writeln;
  if t  = 'D' then begin
    repeat
     writeln('                     Drucker eingeschaltet ? (j/n)');
     readln(s)
    until s  in ['j','J'];
    assign(aus,'PRN');          { Ausgabe auf demm Drucker ... }
    grenze := 50;               { ... max 50 Werte !           }
   end
  else  begin
   assigncrt(aus);              { Ausgabe auf dem Bildschirm ... }
   grenze := 17;                { ... max 17 Werte !             }
   end;
  rewrite(aus);
END;

PROCEDURE Startwert;
{ Ermittelt den Startwert fr die rekursive Berechnung ... }

VAR
  m,s,start        : extended;

Begin
 if abs(n*ln(q)) < 1415.0 then begin
  binomi := exp(n*ln(q));             { ... ber die Funktion exp ... }
  st := 0;
  end
 else begin                           { ... oder zufuss mit Hilfe ... }
  m := n*p;                           { ... des Erwartungswertes  ... }
  s := sqrt(m*(1-p));                 { ... und der Standardabweichung s }
  if s >= 2 then
   start := (m-5*s)
  else
   start := m-20;
  if start < 0 then
   st := 0
  else
   st := round(start);
  write('Der Erwartungswert  liegt bei : ');writeln(m:6:2);
  writeln;
  writeln('Als Startwert wird daher gewhlt k =  - 5*s  ');
  write('                                   = '); writeln(st);
  writeln; writeln;
  writeln(' Bitte etwas Geduld !!! ');
  binomi := binomial(n,st,p);
  clrscr;
 end;
  sum    := binomi;
  str(binomi:6:4,binomi1);
  str(sum:6:4,sum1);
end;

PROCEDURE Kopf;

begin

if t = 'B' then
 clrscr;
 writeln(aus, '                   Binomialverteilung fr n = '+n1+' und p = ' + p1);
 writeln(aus, '');
 writeln(aus, '                               k    B(n,p;k)   F(n,p;k)  ');
 writeln(aus, '                           ------------------------------- ');

end;

PROCEDURE gross (k1 : word) ;
{ Berechnung abbrechen, wenn F(n,p;k) gross genug }

Begin
  if ((sum > 1-epsilon) and (k1 < n-1)) then begin
  writeln(aus, '                             ........');
  binomi := 0;
  z := true;
  writeln(aus, n:32,binomi:12:4,sum:12:4);
 end;
end;

PROCEDURE klein (k2 : word);
{ Werte nicht ausgeben, die kleiner als  sind }

Begin
   l := l + 1;
   if l = 1 then begin
    zeile := succ(zeile);
    writeln(aus,'                            ........');
    end
   else begin
    y := wherey;
    write(k2);
    gotoxy(1,y);
   end;
end;

PROCEDURE warten;

Begin
  if zeile > grenze then begin
   zeile := 0;
   gotoxy(30,24);
   invers; write(' Bitte Taste drcken .... '); normal;
   ja := readkey;
   Kopf;
  end;
end;

FUNCTION  rebinomial( k : word; bin : extended) : extended;
{ Berechnet B(n,p;k) rekursiv }

Begin
 rebinomial := (p/q)*((n-k)/(k+1)) * bin;
end;

PROCEDURE Ausgabe;

Var
    y    : integer;
    k1   : word;

Begin

 l:=0;
 zeile := 1;
 clrscr;
 startwert;
 kopf;
 writeln(aus, '                               0      '+binomi1+'      '+sum1);
 for k1 := st to n-1 do begin
  warten;
  binomi := rebinomial(k1, binomi);
  sum := sum + binomi;
  if (binomi >= epsilon) or (sum >= epsilon) then begin
   zeile := succ(zeile);
   writeln(aus, (k1+1):32,binomi:12:4,sum:12:4);
   gross(k1);
   if z then exit;
  end
  else klein(k1);
 end;
end;

BEGIN
 wahr := true;
 while wahr do begin
 z := false;
 eingabe;
 ausgabe;
 gotoxy(20,24);
 invers; write('Eine weitere Binomialverteilung berechnen ? (J/N) '); normal;
 ja := readkey;
 if (ja = 'J') or (ja = 'j') then
  wahr := true
 else
  wahr := false;
 end;

end.


