{ *********************************************************  }
{                     SIM_HYP.pas                            }
{                                                            }
{                                                            }
{     simuliert Hypothesentests durch Zufallszahlen          }
{                zu einem "wahren Parameter p                }
{                     TURBO PASCAL 6.0                       }
{ **************************************************P******  }

{$N+}
{$IFDEF CPU87} {$ELSE} {$E+} {$ENDIF}
{ emuliert den math. Coprozessor, wenn nicht vorhanden }

PROGRAM Simulation_Hypothesentest;

Uses
  Crt;

TYPE
  string10 = string[10];
  string6  = string[6];
  string250 = string[250];

VAR
p                                  : extended;
n, st                              : word;
m, x, y, zeilen, zeile, i, l, Breite       : integer;
s,t,ja                             : char;
aus                                : text;
wahr,z                             : boolean;
n1,p1,st1                          : string6;
Ho, H1, alpha                      : string10;
sim, simm                          : string250;

CONST
   maxein  = 250;

PROCEDURE Hell;
Begin
 textcolor(3);textbackground(7);
end;

PROCEDURE invers;
Begin
 textcolor(1); textbackground(14);
end;

PROCEDURE normal;
Begin
 textcolor(14); textbackground(1);
end;



PROCEDURE Eingabe;

BEGIN
 clrscr;
 gotoxy(1,1);
 writeln ('            ******************************************************* ');
 writeln ('            *      Simulationen von Stichproben                   * ');
 writeln ('            ******************************************************* ');
 writeln; write;
 write ('       Ho: '); readln (Ho);
 write ('       H1: '); readln (H1);
 write ('       Signifikanzniveau: '); readln(alpha);
 writeln; writeln;
 writeln ('            Bitte geben Sie nun die brigen Parameter ein: ');
 writeln;
 write   ('               Stichprobenumfang (hchstens 250)   n = ');
 x := whereX; y := whereY;
 repeat
  gotoxy(x,y);
  clreol;
  readln(n)
 until ((n>0) and (n < maxein+1));

 writeln;
 write   ('               "wahrer" Parameter fr Erfolg p = ');

 x := whereX; y := whereY;
 repeat
  gotoxy(x,y);
  clreol;
  readln(p)
 until ((p > 0) and (p < 1));
 writeln;
 write('               Anzahl Simulationen: '); readln(st);

str(n:5,n1);
str(p:5:4,p1);
str(st,st1);
writeln; writeln;

repeat
   write('            Ausgabe auf dem (');
   hell; write('B');normal;
   write(')ildschirm oder auf dem (');
   hell; write('D');normal;
   write(')rucker ? ');
   read(t);
   t := upcase(t)
  until t in ['B','D'];
  writeln;
  if t  = 'D' then begin
    repeat
     write('                     Drucker eingeschaltet ? (j/n)');
     readln(s)
    until s  in ['j','J'];
    assign(aus,'PRN');          { Ausgabe auf demm Drucker ... }
    Zeilen := 55;               { ... max 60 Zeilen !           }
    Breite := 70;
   end
  else  begin
   assigncrt(aus);              { Ausgabe auf dem Bildschirm ... }
   Zeilen := 16;                { ... max 16 Zeilen !             }
   Breite := 75;
   end;
  rewrite(aus);
END;


PROCEDURE Kopf;

begin
if t = 'B' then
 clrscr;
 writeln(aus, '                   H y p o t h e s e n t e s t ');
 writeln(aus, '                   Ho: ' +Ho+'    H1: '+H1+'    Signifikanzniveau: ' + alpha);
 writeln;
 writeln(aus, '    '+st1+ ' Stichproben-Simulationen fr n = '+n1+' und "wahres" p = ' + p1);
 writeln(aus, '');

end;


PROCEDURE warten;

Begin
  if zeile > (zeilen-int(n/Breite)-1) then begin
   zeile := 0;
   gotoxy(30,24);
   invers; write(' Bitte Taste drcken .... '); normal;
   ja := readkey;
   Kopf;
  end;
end;


PROCEDURE Ausgabe12;

Var
    i, zahl, eins, laenge, stueck    : integer;
    g    : extended;
    sim1   : string250;
    stueck1, eins1 : string6;

Begin
randomize;
g := n*p;
stueck := 1;
clrscr;
zeile := 0;
kopf;

while stueck < 3 do begin
sim := '';
eins := 0;
for i := 1 to n do
begin
 zahl:=random(n);
 if zahl < g then begin
  sim := concat(sim, '1');
  eins := eins + 1;
 end
 else
  sim := concat(sim, '0');
end;
laenge := length(sim);
str(stueck, stueck1);
writeln(aus, 'Simulation Nr. '+stueck1);
zeile := succ(zeile);
while laenge > 0 do begin
 if laenge > breite then begin
  sim1 := copy(sim,1,Breite);
  sim := copy(sim,breite+1,laenge-Breite);
  writeln(aus,sim1);
  laenge := length(sim);
  zeile := succ(zeile);
  end
 else begin
  writeln(aus, sim);
  str(eins,eins1);
  writeln(aus, '    Anzahl Erfolge (=1) : '+eins1);
  zeile := succ(zeile);
  writeln; zeile := succ(zeile);
  laenge := 0;
  end;
end;
stueck := succ(stueck);
end;
end;


PROCEDURE Ausgabe_ab3;

Var
    i,j, zahl, eins, laenge, stueck    : integer;
    g    : extended;
    sim1, sim2     :string250;
    stueck1, eins1 : string6;

Begin
randomize;
g := n*p;
stueck := 3;
simm := '';

while stueck < st+1 do begin
eins := 0;
for i := 1 to n do
begin
 zahl:=random(n);
 if zahl < g then 
  eins := eins + 1;
end;
str(eins,eins1);
eins1 := eins1 + ', ';
simm := concat(simm,eins1);
laenge := length(simm);
if laenge > 240 then repeat
sim2 := copy(simm, breite-4, 5);
j := pos(',',sim2);
sim1 := copy(simm,1,Breite-4+j);
simm := copy(simm,Breite-3+j, laenge-Breite);
writeln(aus,sim1);
laenge := length(simm);
zeile := succ(zeile);
warten
until laenge <= Breite;

stueck := succ(stueck);
end;

laenge := length(simm);

while laenge > 0 do begin
 if laenge > breite then begin
  sim2 := copy(simm,breite-4, 5);
  j := pos(',',sim2);
  sim1 := copy(simm,1,Breite-4+j);
  simm := copy(simm,breite-3+j,laenge-Breite);
  writeln(aus,sim1);
  laenge := length(simm);
  zeile := succ(zeile);
  warten;
  end
 else 
  writeln(aus, simm);
  laenge := 0;
 end;

end;


BEGIN
 normal;
 wahr := true;
 while wahr do begin
 z := false;
 eingabe;
 ausgabe12;
 writeln(aus,'Fr die folgenden Simulationen werden nur noch die Anzahl der Erfolge angegeben:');
 zeile := succ(zeile);
 ausgabe_ab3;
 gotoxy(20,24);
 invers; write('Eine weitere Simulation durchfhren ? (J/N) '); normal;
 ja := readkey;
 if (ja = 'J') or (ja = 'j') then
  wahr := true
 else
  wahr := false;
 end;

end.


